using System.ComponentModel;

namespace NotifyPerfTests
{
    public class TestVm1 : ViewModel
	{
		private int _counterExplicit;
		public int Explicit
		{
			get { return _counterExplicit; }
			set
			{
				if (_counterExplicit == value)
					return;
				_counterExplicit = value;
				NotifyPropertyChanged("Explicit");
			}
		}

		private int _counterImplicit;
		public int Implicit
		{
			get { return _counterImplicit; }
			set
			{
				if (_counterImplicit == value)
					return;
				_counterImplicit = value;
				NotifyPropertyChanged();
			}
		}

		private int _counterExpr;
		public int Expr
		{
			get { return _counterExpr; }
			set
			{
				if (_counterExpr == value)
					return;
				_counterExpr = value;
				NotifyPropertyChanged(() => Expr);
			}
		}

		private int _counterObj;
		public int CounterObj
		{
			get { return _counterObj; }
			set
			{
				if (_counterObj == value)
					return;
				_counterObj = value;
				NotifyObjectChanged();
			}
		}

		private int _staticArgs;
		static readonly PropertyChangedEventArgs args = new PropertyChangedEventArgs("StaticArgs");
		public int StaticArgs
		{
			get { return _staticArgs; }
			set
			{
				if (_staticArgs == value)
					return;
				_staticArgs = value;
				NotifyPropertyChanged(args);
			}
		}

        private int _staticNameOfArgs;
        static readonly PropertyChangedEventArgs args2 = new PropertyChangedEventArgs(nameof(StaticNameOfArgs));
        public int StaticNameOfArgs
        {
            get { return _staticNameOfArgs; }
            set
            {
                if (_staticNameOfArgs == value)
                    return;
                _staticNameOfArgs = value;
                NotifyPropertyChanged(args2);
            }
        }
    }
}
